#dependencies:
# python imaging libray und imagemagick

import urllib,os,re
from PIL import Image
from math import *
from collections import *
from vector import *

raincolors = {
0xf6f600:0.1, 
0xffc400:0.3, 
0xf65a00:0.6, 
0xd80057:1.2, 
0x9c1100:2.0, 
0xf646f6:3.5, 
0xf69ff3:5.0, 
0x8000b6:8.0, 
0x346bbe:12.0, 
0x27afaf:18.0, 
0x89ded7:24.0, 
0x005800:32.0, 
0x009600:40.0, 
0x00cc25:50.0, 
0xb4ed85:65.0, 
0xeffcdc:80.0, 
0xffffff:100.0}

class mydict(dict):
    def __missing__(key,bla):
        return 0

colors = mydict(raincolors)

karlsruhe = vecn(231,254)
futureKarlsruhe = "bla"
pixelsize = 60.0/124.0 #pixel size in km (60km bzw 124 pixel nach heilbronn)
lag = 1.0 + 5.0/60 #time lag is 1 hour + 5min on average
prediction = 10.0/60 #how many hours to look ahead beyond the lag
windangle = "bla"
windspeed = "bla"

def sqr(n):
    return n*n

def relevance (point):
    relativePoint = (point-futureKarlsruhe).rotate(windangle).scale(1/240.0) #normalizen
    x = relativePoint.x
    y = relativePoint.y
    
    return max(0,1 - abs(sqr(2*x) + sqr(2.2*(y+0.05) + abs((y+0.05))*3))) #magic

def toHex(color):
    return color[0]*256*256 + color[1]*256 + color[2]


def raininess(image):
    result = 0
    pixels = image.load()
    for x in range(0,480):
        for y in range(0,480):
            rel = relevance(vecn(x,y))
            result += rel*colors[toHex(pixels[x,y])]
            if rel > 0:
                color = vecn(pixels[x,y]).scale(0.2)
                color = color + vecn(rel*255,0,0)
                          
                pixels[x,y] = tuple(map(int,color.data))
    image.save("relevance.png")
    return log(result+1)/3


def main():
    global futureKarlsruhe,windangle,windspeed
    urllib.urlretrieve("http://radar-info.fzk.de/Radarbilder/Bilder/Niederschlag-0.gif","radar.gif")

    #wind am boden ist oft ganz anders. TODO: aus der animation windgeschwindigkeit+richtung schaetzen
    foo = urllib.urlopen("http://radar-info.fzk.de/WindWarn.js")
    
    wind = foo.read()
    foo.close()
    windspeed = float(re.search("bodennahe Schicht (.*) km/h",wind).group(1))
    windangle = -(float(re.search("Richtung: (.*) Grad",wind).group(1))*pi/180 - pi/2) #winkel kommt um pi/2 vedreht an und ist in mathematisch negativem sinn >.<
    futureKarlsruhe = karlsruhe + vecn(0,windspeed*pixelsize*(lag+prediction)).rotate(windangle)
    
    os.system("convert radar.gif -crop 480x480+0+0 radar.png") 
    orig = Image.open("radar.png")
    print raininess(orig)

main()

